<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>task 26.10 Load all orders - Danh sách đơn hàng</title>
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  </head>

  <body onload="onPageLoading()">
    <div class="container-fluid">
      <div class="row">
        <div class="col-12">
          <h2 class="text-center">Danh sách đơn hàng</h2>
          <table class="table text-center table-striped" id="table-order">
            <thead>
              <tr>
                <th scope="col">Order Code</th>
                <th scope="col">Kích cỡ combo</th>
                <th scope="col">Loại pizza</th>
                <th scope="col">Nước uống</th>
                <th scope="col">Thành tiền</th>
                <th scope="col">Họ và tên</th>
                <th scope="col">Số điện thoại</th>
                <th scope="col">Trạng thái</th>
                <th class="" style="width: 15%" scope="col">Chi tiết</th>
              </tr>
            </thead>
            <tbody></tbody>
          </table>
        </div>
      </div>
    </div>

    <script>
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      const gREQUEST_STATUS_OK = 200;
      const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
      const gREQUEST_DELETE_SUCCESS = 204; // status 204 - Xóa thành công
      const gCOL_ORDER = 0;
      const gCOL_KICH_CO = 1;
      const gCOL_LOAI_PIZZA = 2;
      const gCOL_LOAI_NUOC = 3;
      const gCOL_THANH_TIEN = 4;
      const gCOL_HO_TEN = 5;
      const gCOL_SO_DIEN_THOAI = 6;
      const gCOL_TRANG_THAI = 7;
      const gCOL_CHI_TIET = 8;
      const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders/";

      /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      // Hàm thực hiện khi load trang
      function onPageLoading() {
        getAllOrders();
      }
      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      // Hàm thực hiện việc load all orders từ server và load vào table
      function getAllOrders() {
        var vXmlHttpGetAllOrders = new XMLHttpRequest();
        callApiToGetAllOrders(vXmlHttpGetAllOrders);

        // B4: Xử lý trên front-end khi request xử lý xong và trả về response thành công
        vXmlHttpGetAllOrders.onreadystatechange = function () {
          if (
            this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
            this.status == gREQUEST_STATUS_OK
          ) {
            loadOrderToTable(vXmlHttpGetAllOrders);
          }
        };
      }

      /**
       * Chia để trị - 04 bước cố gắng thành 04 functions riêng biệt
       */
      // B1: Thu thập dữ liệu (trong bài này bước này ko cần)
      // B2: Validate dữ liệu (trong bài này bước này ko cần)
      // B3: Thực hiện việc gọi API từ server Server

      // hàm gọi api để lấy all orders
      function callApiToGetAllOrders(paramXMLHttpGetAllOrders) {
        const vBaseUrl = "http://203.171.20.210:8080/devcamp-pizza365/orders";
        paramXMLHttpGetAllOrders.open("GET", vBaseUrl, true);
        paramXMLHttpGetAllOrders.send();
      }

      // input: xml http request đã đươc trả lời
      // ouptut/end: dữ liệu hiên thi trên bảng
      function loadOrderToTable(paramXMLHttpAllOrder) {
        //CODE Ở ĐÂY ĐỂ LOAD DATA VÀO TABLE
        var vOrderObj = JSON.parse(paramXMLHttpAllOrder.responseText);

        var vTableOrder = document.getElementById("table-order");
        var vTableBody = vTableOrder.getElementsByTagName("tbody")[0];

        for (var bI = 0; bI < vOrderObj.length; bI++) {
          var vNewRow = vTableBody.insertRow(-1);

          var vCellOrderCode = vNewRow.insertCell(gCOL_ORDER);
          var vCellKichCo = vNewRow.insertCell(gCOL_KICH_CO);
          var vCellLoaiPizza = vNewRow.insertCell(gCOL_LOAI_PIZZA);
          var vCellLoaiNuoc = vNewRow.insertCell(gCOL_LOAI_NUOC);

          var vCellThanhTien = vNewRow.insertCell(gCOL_THANH_TIEN);
          var vCellHoTen = vNewRow.insertCell(gCOL_HO_TEN);
          var vCellSoDienThoai = vNewRow.insertCell(gCOL_SO_DIEN_THOAI);

          var vCellTrangThai = vNewRow.insertCell(gCOL_TRANG_THAI);
          var vCellChiTiet = vNewRow.insertCell(gCOL_CHI_TIET);

          vCellOrderCode.innerHTML = vOrderObj[bI].orderCode;
          vCellKichCo.innerHTML = vOrderObj[bI].kichCo;
          vCellLoaiPizza.innerHTML = vOrderObj[bI].loaiPizza;
          vCellLoaiNuoc.innerHTML = vOrderObj[bI].idLoaiNuocUong;
          vCellHoTen.innerHTML = vOrderObj[bI].hoTen;
          vCellThanhTien.innerHTML = vOrderObj[bI].thanhTien;
          vCellSoDienThoai.innerHTML = vOrderObj[bI].soDienThoai;

          vCellTrangThai.innerHTML = vOrderObj[bI].trangThai;

          var bNewButton = document.createElement("button");
          var bNewButtonDelete = document.createElement("button");
          bNewButton.innerHTML = "Chi Tiết";
          bNewButton.className = "btn btn-primary";
          vCellChiTiet.appendChild(bNewButton);

          bNewButton.setAttribute("data-id", vOrderObj[bI].id);
          bNewButtonDelete.setAttribute("data-id", vOrderObj[bI].id);
          bNewButton.setAttribute("data-ordercode", vOrderObj[bI].orderCode);

          bNewButton.addEventListener("click", function () {
            getDataBtn(this);
          });

          bNewButtonDelete.innerHTML = "Xóa";
          bNewButtonDelete.className = "ml-2 btn btn-danger";
          vCellChiTiet.appendChild(bNewButtonDelete);

          bNewButtonDelete.addEventListener("click", function () {
            if (window.confirm("Bạn thật sự muốn xóa")) {
              deleteOrder(this);
              window.location.href = "indexListView.html";
            } else {
              window.location.href = "indexListView.html";
            }
          });
        }
      }
      //   dataset button
      function getDataBtn(param) {
        var vId = param.dataset.id;
        var vOrderCode = param.dataset.ordercode;
        console.log(vId);
        console.log(vOrderCode);
        var vLink = "OrderDetail.html";
        var vLinkObj = vLink + "?id=" + vId + "&" + "orderCode=" + vOrderCode;
        window.location.href = vLinkObj;
      }
      function deleteOrder(param) {
        var vId = param.dataset.id;
        console.log("id delete:" + vId);
        var vXmlHttp = new XMLHttpRequest();
        goiApiDeleteOrder(vXmlHttp, vId);
        vXmlHttp.onreadystatechange = function () {
          if (
            vXmlHttp.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
            vXmlHttp.status == gREQUEST_DELETE_SUCCESS
          ) {
            alert("xóa thành công!");
          }
        };
      }
      // goi api de xoa order
      function goiApiDeleteOrder(paramXmlHttp, paramId) {
        paramXmlHttp.open("DELETE", gBASE_URL + paramId, true);
        paramXmlHttp.send();
      }
      //
    </script>
  </body>
</html>
